/***
 * This file plagarized from "gcc/gcc-include/assert.h"
 * Allow statements of the form check( X > Y ); which
 * will print out an error message and exit if they are
 * not true.
 * Should work with gcc or cc, provided that the preprocessor
 * does macro substitution inside strings.
 */
#ifndef _check_
#define _check_

#define implies(x,y) (!(x) || (y))

#ifdef __STDC__

void __eprintf ();              /* Defined in gnulib */

#define check(expression)  \
  ((expression) ? 0 : __check (#expression, __FILE__, __LINE__))

#define __check(expression, file, line)  \
  (__eprintf ("Failed check (" expression            \
              ") at line %d of `" file "'.\n", line),    \
   exit (1))

#else /* no __STDC__; i.e. -traditional.  */

#define check(expression) \
  ((expression) ? 0 : (fprintf (stderr, "Failed check (%s) at line %d of `%s'.\n", "expression", __LINE__, __FILE__),    \
   exit (1)))

#endif /* no __STDC__; i.e. -traditional.  */

#endif
