/*
**  USEFUL.H -- various definitions of general interest
**
**	$Header: useful.h, v 2.0 89/12/24 00:56:33 eric Exp $
**
**	Author:
**		Eric Allman
**		University of California, Berkeley
*/

#ifndef _USEFUL_H_
#define _USEFUL_H_

#include <stdio.h>
#include <ctype.h>
#include <varargs.h>
#include <assert.h>
#include <strings.h>

/* give a stab at the multiple-language dilemma */
#if defined(__STDC__)
#define ARGS(x)		x
#define NOARGS		(void)
typedef void generic;	/* is this right ? */
#define COMPILER "__STDC__"
#endif

#if defined(sgi)
#define ARGS(x)		x
#define NOARGS		(void)
typedef char generic;
#define COMPILER "__SGI_STDC__"
#endif

#ifndef COMPILER
typedef char generic;
#define ARGS(x)		()
#define NOARGS		()
#define COMPILER "!__STDC__"
#endif


#ifndef TRUE
#define TRUE		1
#define FALSE		0
#define UNDEFINED	-1
#endif

#define truth(x) ((x)==TRUE ? true_string : (x)==FALSE ? false_string : (x)==UNDEF ? undefined_string : bad_boolean_string)

#ifndef boolean
#define boolean		int
#endif

extern FILE *dout;

#ifdef __STDC__
#include <string.h>
#else
extern char	*strchr ARGS((char *, char));
extern char	*strrchr ARGS((char *, char));
#endif

extern char *realloc ARGS((char *, unsigned int));
extern char *reallocOrAbort ARGS((char *, unsigned int));
extern char *calloc ARGS((unsigned int, unsigned int));
extern char *callocOrAbort ARGS((unsigned int, unsigned int));

#define Realloc(TYPE, OLD, NUMBER) \
  ((TYPE*)realloc((char*)(OLD), sizeof(TYPE)*(unsigned) (NUMBER)))
#define ReallocOrAbort(TYPE, OLD, NUMBER) \
  ((TYPE*)reallocOrAbort((char*)(OLD), sizeof(TYPE)*(unsigned) (NUMBER)))

#define Calloc(TYPE, N) \
  ((TYPE*)calloc((unsigned) (N), (unsigned)sizeof(TYPE)))
#define CallocOrAbort(TYPE, N) \
  ((TYPE*)callocOrAbort((unsigned) (N), (unsigned)sizeof(TYPE)))
#define ITempCalloc(TYPE, N) \
  ((TYPE*)calloc((unsigned) (N), (unsigned)sizeof(TYPE)))
#define ITempRealloc(TYPE, OLD, N) \
  ((TYPE*)realloc((char*)(OLD), (unsigned) (N) * (unsigned)sizeof(TYPE)))

extern char *pchar ARGS((char));
extern void strncpy_null ARGS((char*, char*, int));
extern char *strcpyend ARGS((char*, char*));
extern char *strcatend ARGS((char*, char*));

#ifndef REAL_DEFINED
#define real float
#define REAL_DEFINED
#endif REAL_DEFINED

extern char *myname;
extern char *true_string;
extern char *false_string;
extern char *undefined_string;
extern char *bad_boolean_string;
extern char *BooleanString ARGS((int));
extern int stand_alone;	/* 1 if this is in a program, 0 if in a command */
extern int IsAsciiString ARGS((char *));

extern void Abort ARGS(());
extern void ErrorAbort ARGS(());
extern void Error ARGS(());
extern void ErrorV ARGS((va_list*));
extern char *SysError ARGS((int));

#endif /* _USEFUL_H_ */
