#include <stdio.h>
#include <math.h>
/*
#include "../numrec/nrutil.h"
#include "../include/assert.h"
*/
typedef enum DIRECTION {UP, LEFT, RIGHT, DOWN} DIRECTION;

#define assert(X)
#define DB(X)
  
int int_arg(argv)
char **argv;
{
  if (!*argv) {
    fprintf(stderr, "Expected integer argument after \"%s\"\n", (*argv)[-1]);
    exit(1);
  }
  return atoi(*argv);
}

char *str_arg(argv)
char **argv;
{
  if (!*argv) {
    fprintf(stderr, "Expected string argument after \"%s\"\n", (*argv)[-1]);
    exit(1);
  }
  return *argv;
}

float real_arg(argv)
char **argv;
{
  if (!*argv) {
    fprintf(stderr, "Expected real argument after \"%s\"\n", (*argv)[-1]);
    exit(1);
  }
  return atof(*argv);
}

char *my_name;
PrintUsageAndExit()
{
    fprintf(stderr, "usage: %s\t(-d|-dx|-dy) diagram-dimension\n\t\t(-c|-cx|-cy) char-dimension\n\t\t(-cd|-x|-y) dimension\n\t\t[-n number of chars] [-border] [-grey] [-show] [-nobdf] [-power N]\n", my_name);
    exit(1);
}

int blot=0;
int nblocks=1;
int descender=0;
int do_stats=0;
int version=1;
/* ARGSUSED */
main(argc, argv)
int argc;
char *argv[];
{
  char **array, *array0;
  char *name=NULL;
  extern char *calloc();
  FILE *text;
  DIRECTION direction;
  int x, y, dx, dy, cx, cy, i, j, count, prev_printed, horiz_n_chars, vert_n_chars;
  int num_blots, n, show, border, grey, bdf, lines, thick, num_chars, blot;
  int do_lines_and_edges=0;
  int num_printed;
  float power=0.7;
  char c;
  my_name = argv[0];
  show = 0;
  border = 0;
  thick = 0;
  grey = 0;
  bdf = 1;
  dx=dy=cx=cy=16;
  num_blots=24;
  while (*argv && *++argv) {
    if (!strcmp("-grey", *argv))
      grey = 1;
    else if (!strcmp("-shade", *argv))
      grey = 2;
    else if (!strcmp("-show", *argv))
      show = 1;
    else if (!strcmp("-stats", *argv)) {
      do_stats = 1;
      bdf = 0;
    } else if (!strcmp("-blot", *argv))
      blot = 1;
    else if (!strcmp("-border", *argv))
      border =1 ;
    else if (!strcmp("-thick", *argv))
      thick =1 ;
    else if (!strcmp("-nobdf", *argv))
      bdf =0;
    else if (!strcmp("-d", *argv)) {
      argv++;
      dx = dy = int_arg(argv);
    } else if (!strcmp("-power", *argv)) {
      argv++;
      power = real_arg(argv);
    } else if (!strcmp("-version", *argv)) {
      argv++;
      version = int_arg(argv);
    } else if (!strncmp("-des", *argv, 3)) {
      argv++;
      descender = int_arg(argv);
    } else if (!strcmp("-dx", *argv)) {
      argv++;
      dx = int_arg(argv);
    } else if (!strcmp("-dy", *argv)) {
      argv++;
      dy = int_arg(argv);
    } else if (!strcmp("-c", *argv)) {
      argv++;
      cx = cy = int_arg(argv);
    } else if (!strcmp("-cx", *argv)) {
      argv++;
      cx = int_arg(argv);
    } else if (!strcmp("-cy", *argv)) {
      argv++;
      cy = int_arg(argv);
    } else if (!strcmp("-x", *argv)) {
      argv++;
      dx = cx = int_arg(argv);
    } else if (!strcmp("-y", *argv)) {
      argv++;
      dy = cy = int_arg(argv);
    } else if (!strcmp("-cd", *argv)) {
      argv++;
      dx = dy = cx = cy = int_arg(argv);
    } else if (!strcmp("-n", *argv)) {
      argv++;
      num_blots = int_arg(argv);
    } else if (!strcmp("-name", *argv)) {
      argv++;
      name = str_arg(argv);
    } else {
      fprintf(stderr, "Unknown option: \"%s\"\n", *argv);
      PrintUsageAndExit();
    }

  }
  horiz_n_chars = dx/cx;
  if (dx % cx) horiz_n_chars++;
  vert_n_chars = dy/cy;
  if (dy % cy) vert_n_chars++;
  num_chars = horiz_n_chars * vert_n_chars * (num_blots * 2 - 1);

  text = stderr;

  /* array = cmatrix(0, dy-1, 0, dx-1); */
  array = (char**)calloc(dy, sizeof(char*));
  array0 = calloc(dy, dx);
  for (y=0;y<dy;y++)
	array[y] = array0+y*(dx);

 count_blots:
  SetBlank(array, dx, dy, border);
  prev_printed = -1;
  count = 0;
  /*
   * first show the chars
   */
  n = 0;
  for (;;) {
    if (print_this(prev_printed, count, dx, dy, num_blots, border, power)) {
      prev_printed = count;
      if (show) {
	fprintf(text, "Char %d\n", n);
	for (j=dy-1;j>=0;j--) {
	  for (i=0;i<dx;i++) {
	    c = array[j][i];
	    if ((grey==1 && (i+j)%2) || (grey==2 && (j%3)==0)) c='#';
	    putc(c, text);
	  }
	  putc('\n', text);
	}
	fflush(text);
      }
      n++;
    }
    if (!find_next_larger(dx, dy, array)) break;
    count++;
  }

  if (n<num_blots) {
    fprintf(stderr, "Warning: didn't find enough blots! (found %d at pow %g)\n",
	    n, power);
    if (power<1.0) {
      power += 0.02*(num_blots-n)*(ceil((1-power)*100+0.1)/100);
      goto count_blots;
    }
    exit(1);
  }

  if (n*horiz_n_chars*vert_n_chars>111) {
    fprintf(stderr, "Too many chars (%d)\n", n);
    exit(1);
  }

  if (!bdf) exit(0);

  /*
   * and now print them
   */
  if (bdf) print_bdf_header(stdout, cx, cy, num_chars, horiz_n_chars, name);
  SetBlank(array, dx, dy, border);
  prev_printed = -1;
  count = 0;
  n = 33;
  blot=1;
  for (;;) {
    if (print_this(prev_printed, count, dx, dy, num_blots, border, power)) {
      if (do_stats) fprintf(stdout, "%d %d\n%d %d\n", count, blot, count+1, blot);
      prev_printed = count;
      if (bdf) print_bdf_char(stdout, n, array, dx, dy, cx, cy, 0, grey, count, blot++);
      n += horiz_n_chars * vert_n_chars;
    } else {
      if (do_stats) fprintf(stdout, "%d %d\n%d %d\n", count, 0, count+1, 0);
    }
    count++;
    if (!find_next_larger(dx, dy, array)) break;
  }

  /*
   * print them inverse
   */
  SetBlank(array, dx, dy, border);
  prev_printed = -1;
  num_printed = 0;
  count = 0;
  for (;;) {
    if (print_this(prev_printed, count, dx, dy, num_blots, border, power)) {
      prev_printed = count;
      num_printed++;
      n+=print_bdf_char(stdout, n, array, dx, dy, cx, cy, 1, grey, count, blot++);
    }
    count++;
    if (!find_next_larger(dx, dy, array) || num_printed>=num_blots-1) break;
  }

  if (do_lines_and_edges) {
    /*
     * print the lines
     */
    count = 0;
    for (count=0;count<16;count++) {
      for (x=0;x<cx;x++) for (y=0;y<cy;y++) array[y][x]='.';
      if (count&1) for (x=0;x<cx/2;x++) array[cy/2][x]='#';
      if (count&2) for (x=cx/2;x<cx;x++) array[cy/2][x]='#';
      if (count&4) for (y=0;y<cy/2;y++) array[y][cx/2]='#';
      if (count&8) for (y=cy/2;y<cy;y++) array[y][cx/2]='#';
      if (thick) {
	if (count&1) for (x=0;x<cx/2;x++) array[cy/2-1][x]='#';
	if (count&2) for (x=cx/2;x<cx;x++) array[cy/2-1][x]='#';
	if (count&4) for (y=0;y<cy/2;y++) array[y][cx/2-1]='#';
	if (count&8) for (y=cy/2;y<cy;y++) array[y][cx/2-1]='#';
      }
      print_bdf_char(stdout, 127-count, array, dx, dy, cx, cy, 0, grey, count, blot++);
    }
    /*
     * print the edges
     */
    count = 0;
    for (count=0;count<16;count++) {
      for (x=0;x<cx;x++) for (y=0;y<cy;y++) array[y][x]='.';
      if (count&1) for (x=0;x<cx;x++) array[0][x]='#';
      if (count&2) for (x=0;x<cx;x++) array[cy-1][x]='#';
      if (count&4) for (y=0;y<cy;y++) array[y][0]='#';
      if (count&8) for (y=0;y<cy;y++) array[y][cx-1]='#';
      if (thick) {
	if (count&1) for (x=0;x<cx;x++) array[1][x]='#';
	if (count&2) for (x=0;x<cx;x++) array[cy-2][x]='#';
	if (count&4) for (y=0;y<cy;y++) array[y][1]='#';
	if (count&8) for (y=0;y<cy;y++) array[y][cx-2]='#';
      }
      print_bdf_char(stdout, 255-count, array, dx, dy, cx, cy, 0, grey, count, blot++);
    }
  }
  print_bdf_trailer(stdout);
}

SetBlank(array, dx, dy, border)
char **array;
int dx, dy, border;
{
  int x, y;
  for (x=0;x<dx;x++)
    for (y=0;y<dy;y++)
      array[y][x]='.';
  if (border) {
    for (x=0;x<dx;x++) {
      array[0][x]='#';
      array[dy-1][x]='#';
    }
    for (y=0;y<dy;y++) {
      array[y][0]='#';
      array[y][dx-1]='#';
    }
  }
}

int print_bdf_char(out, n, array, dx, dy, cx, cy, invert, grey, count, blot_num)
int n, dx, dy, cx, cy, invert, grey, count, blot_num;
char **array;
FILE *out;
{
  int j, i, c;
  assert(dx==cx || (dx>cx && (dx%cx==0)));
  assert(dy==cy);
  for (c=0;c<dx/cx;c++) {
    print_bdf_char_header(out, n+c, cx, cy, count);
    for (j=cy-1;j>=0;j--) {
      print_bit_vector_in_hex(array[j]+(c*cx), cx, out, invert, j, grey, c*cx+blot_num*dx);
    }
    print_bdf_char_end(out);
  }
  return dx/cx;
}

print_bdf_char_header(out, n, cx, cy, count)
int n, cx, cy, count;
{
  fprintf(out, "STARTCHAR HINTON%d-%d\n", n, count);
  fprintf(out, "ENCODING -1 %d\n", n);
  fprintf(out, "SWIDTH 1000 0\n");
  fprintf(out, "DWIDTH %d 0\n", cx);
  fprintf(out, "BBX %d %d 0 %d\n", cx, cy, -descender);
  fprintf(out, "BITMAP\n");
}

print_bdf_char_end(out)
FILE *out;
{
  fprintf(out, "ENDCHAR\n");
}

/*
 * this version uses linear scaling
 */
int print_this_lin(prev_printed, count, dx, dy, num_blots, border)
{
  int total;
  float p, q;
  if (border) total=(dx-2)*(dy-2);
  else total=dx*dy;
  if (count==total || count==0) return 1;
  if (count > total) return 0;

  count = total-count; /* we fill in from the outside */
  p = count*(num_blots-1)/(float)total;
  q = (count-1)*(num_blots-1)/(float)total;
  if ((int)p != (int)q) return 1;
  return 0;
}

/*
 * this version uses variable power scaling
 */
int print_this(prev_printed, count, dx, dy, num_blots, border, power)
float power;
{
  int total;
  float p, q=0;
  if (border) total=(dx-2)*(dy-2);
  else total=dx*dy;
  p=q=0;

  count = total-count; /* we fill in from the outside */
  if (count>0)
    p = (num_blots-1) * exp(log(count/(float)total)*power);
  if (count>1)
    q = (num_blots-1) * exp(log((count-1)/(float)total)*power);
  /*fprintf(stderr, "%3d %3d %9g %9g %d\n", total, count, p, q, ((int)p)!=(int)q);*/
  if (count==total || count==0) return 1;
  if (count > total) return 0;
  if ((int)p != (int)q) return 1;
  return 0;
}

/*
 * returns the number of '#'s surrounding this point
 */
int surround(x, y, mx, my, array)
int x, y, mx, my;
char **array;
{
  int i=0;
  if (blot) return 0;
  my--;mx--;
  if (          x > 0  && array[y  ][x-1]=='#') i++;
  if (y > 0            && array[y-1][x  ]=='#') i++;
  if (y < my           && array[y+1][x  ]=='#') i++;
  if (          x < mx && array[y  ][x+1]=='#') i++;
  return i;
}

/*
 * returns 1 if this point is next to the last one
 */
int x_last, y_last;
int next_to_last(x, y)
{
  int r;
  if (x_last-x>=-1 && x_last-x<=1 && y_last==y) r=0;
  else if (x_last==x && y_last-y>=-1 && y_last-y<=1) r=0;
  else if (x_last-x>=-1 && x_last-x<=1 && y_last-y>=-1 && y_last-y<=1) r=1;
  else r=2;
  DB( putchar(r==0?':':r==1?'.':' '); )
  return r;
}

int find_next_larger_old(dx, dy, array)
int dx, dy;
char **array;
{
  float x_mid, y_mid, x_dist, y_dist, y_inc, x_inc, lmin, hmin, hd, ld;
  double fabs();
  int at_y, at_x, max_s, s;
  int x, y, at_mid;
  x_last = y_last = -2;
  x_mid = (dx-1)/2.0;
  y_mid = (dy-1)/2.0;
  x_inc = y_inc = 0;
  at_x = at_y = max_s = 0;
  if (dx<dy) x_inc = (dy-dx)/2.0;
  else y_inc = (dx-dy)/2.0;
  /* printf("x_mid=%-6g y_mid=%-6g x_inc=%-6g y_inc=%-6g\n", x_mid, y_mid, x_inc, y_inc); */
  hmin = (dx>dy?dx:dy);
  for (x=0;x<dx;x++) {
    for (y=0;y<dy;y++) if (array[y][x]=='.') {
      x_dist = x_inc+fabs(x_mid-x);
      y_dist = y_inc+fabs(y_mid-y);
      s = surround(x, y, dx, dy, array) + next_to_last(x, y);
      at_mid=0;
      if (x_dist>y_dist) {
	hd=x_dist;
	ld=y_dist;
	if (x_dist-x_inc<=0.5) at_mid=1;
      } else {
	ld=x_dist;
	hd=y_dist;
	if (y_dist-y_inc<=0.5) at_mid=1;
      }
      /* printf("x=%-2d y=%-2d s=%-2d at_x=%-2d at_y=%-2d xd=%-6g yd=%-6g ld=%-6g hd=%-6g lm=%-6g hm=%-6g max_s=%-2d\n",
	     x, y, s, at_x, at_y, x_dist, y_dist, ld, hd, lmin, hmin, max_s); */
      if (   hd<hmin
	  || (!blot && hd==hmin && s>max_s)
	  || (!blot && at_mid && hd==hmin && s==max_s && ld<lmin)
	  || (blot && hd==hmin && ld<lmin)) {
	at_x = x;
	at_y = y;
	lmin = ld;
	hmin = hd;
	max_s = s;
      }
    }
  }
  if (hmin == (dx>dy?dx:dy)) return 0;
  array[at_y][at_x]='#';
  return 1;
}

int find_next_larger(dx, dy, array)
int dx, dy;
char **array;
{
  int x_dist, y_dist, min_dist, dist, dmax;
  int at_y, at_x;
  int x, y, at_mid;
  at_x = at_y = -1;
  dmax = (dx>dy?dx:dy);
  min_dist = 4*(dx + dy);
  for (y=0;y<dy;y++) {
    for (x=0;x<dx;x++) {
      if (array[y][x]=='.') {
	if (x>dx-1-x)
	  x_dist = dx-1-x;
	else
	  x_dist = x;
	if (y>dy-1-y)
	  y_dist = dy-1-y;
	else
	  y_dist = y;
	if (x_dist/(float)dx>y_dist/(float)dy)
	  dist = 4*dmax*y_dist/(float)dy + next_to_last(x, y);
	else
	  dist = 4*dmax*x_dist/(float)dx + next_to_last(x, y);
	if (dist < min_dist) {
	  at_x = x;
	  at_y = y;
	  min_dist = dist;
	}
	DB( printf("%-2d ", dist); )
      } DB( else printf(" -- "); )
    }
    DB( printf("\n"); )
  }
  if (at_x == -1) {
    x_last = y_last = 0;
    return 0;
  }
  x_last = at_x;
  y_last = at_y;
  array[at_y][at_x]='#';
  return 1;
}

calc_next_larger(direction, x, y, dx, dy, array)
int *x, *y, dx, dy;
DIRECTION *direction;
char **array;
{
  switch (*direction) {
  case UP:
    (*y)++;
    if (*x<0 || *x>=dx || *y<0 || *y>=dy) break;
    array[*y][*x]='#';
    if (array[*y][*x+1]=='.') *direction=RIGHT;
    break;
  case LEFT:
    (*x)--;
    if (*x<0 || *x>=dx || *y<0 || *y>=dy) break;
    array[*y][*x]='#';
    if (array[*y+1][*x]=='.') *direction=UP;
    break;
  case RIGHT:
    (*x)++;
    if (*x<0 || *x>=dx || *y<0 || *y>=dy) break;
    array[*y][*x]='#';
    if (array[*y-1][*x]=='.') *direction=DOWN;
    break;
  case DOWN:
    (*y)--;
    if (*x<0 || *x>=dx || *y<0 || *y>=dy) break;
    array[*y][*x]='#';
    if (array[*y][*x-1]=='.') *direction=LEFT;
    break;
  }
}

print_bit_vector_in_hex(v, cx, file, invert, j, grey, offset)
char *v;
int cx, invert, j, grey, offset;
FILE *file;
{
  int i, iterations;
  unsigned long h;
  char c;
  /* iterate a multiple of 8 times */
  h = 0;
  iterations = ((cx+7)/8)*8;
  for (i=0;i<iterations;i++) {
    h <<= 1;
    c = v[i];
    if ((grey==1 && (i+j+offset+invert)%2) || (grey==2 && ((j%3)==0)!=invert))
      c='.';
    h |= (i>=cx ? 0 : (c=='.'));
    if ((i % 4)==3) {
      fprintf(file, "%1X", (invert ? ~h : h) & 0xF);
      h=0;
    }
  }
  fprintf(file, "\n");
}

print_bdf_header(out, xsize, ysize, chars, chars_per_blot, name)
FILE *out;
int xsize, ysize, chars;
char *name;
{
  char cpb[10];
  if (chars_per_blot<2) cpb[0] = 0;
  else sprintf(cpb, "%d", chars_per_blot);
  fprintf(out, "STARTFONT 2.1\n");
  if (name==NULL)
    fprintf(out, "FONT %dx%d.blot%s\n", xsize, ysize, cpb);
  else
    fprintf(out, "FONT %s\n", name);
  fprintf(out, "SIZE %d 75 75\n", xsize);
  fprintf(out, "FONTBOUNDINGBOX %d %d 0 %d\n", xsize, ysize, -descender);
  fprintf(out, "STARTPROPERTIES 4\n");
  fprintf(out, "FONT_ASCENT %d\n", ysize-descender);
  fprintf(out, "FONT_DESCENT %d\n", descender);
  fprintf(out, "DEFAULT_CHAR 33\n");
  fprintf(out, "VERSION %d\n", version);
  fprintf(out, "ENDPROPERTIES\n");
  fprintf(out, "CHARS %d\n", chars);
}

print_bdf_trailer(out)
FILE *out;
{
  fprintf(out, "ENDFONT\n");
}
