/*
 * $Id: config.h,v 1.1 90/12/07 11:50:18 drew Exp $
 * 
 * $Log:	config.h,v $
# Revision 1.1  90/12/07  11:50:18  drew
# Initial revision
# 
 */

/**********************************************************************
 * Copyright 1990,1991 by University of Toronto, Toronto, Ontario, Canada.
 * 
 *			 All Rights Reserved
 * 
 * Permission to use, copy, modify, distribute, and sell this software
 * and its documentation for any purpose is hereby granted without fee, 
 * provided that the above copyright notice appears in all copies and that 
 * both the copyright notice and this permission notice appear in 
 * supporting documentation, and that the name of University of Toronto 
 * not be used in advertising or publicity pertaining to distribution 
 * of the software without specific, written prior permission.  
 * University of Toronto makes no representations about the suitability 
 * of this software for any purpose. It is provided "as is" without 
 * express or implied warranty. 
 *
 * UNIVERSITY OF TORONTO DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS 
 * SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND 
 * FITNESS, IN NO EVENT SHALL UNIVERSITY OF TORONTO BE LIABLE FOR ANY 
 * SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER 
 * RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF 
 * CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN 
 * CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 *
 **********************************************************************/

/***
 * Configuration file - try to put all machine dependent stuff in here
 */

#if defined(__STDC__) || defined(sgi)
/* this gets used with gcc - allows function argument checking */
#define ARGS(x)		x
#define NOARGS		(void)
#define COMPILER "__STDC__"
#else
/* and this gets used with cc */
#define ARGS(x)		()
#define NOARGS		()
#define COMPILER "NOT __STDC__"
#endif

typedef char generic;

/***
 * This is a multi-system version of the config.h file, it includes the
 * appropriate one:
 */

#if defined(sgi)
#include "config.sgi.h"
#endif

#if defined(mips) && !defined(sgi)
#include "config.mips.h"
#endif

#if defined(sun)
#include "config.sun.h"
#endif

#if defined(stellar)
#include "config.stellar.h"
#endif


/* toronto system: @(#)signal.h 2.29 88/03/03 SMI; from UCB 6.7 85/06/08   */
/* dupont  system: @(#)signal.h 1.2 86/10/07 SMI; from UCB 6.7 85/06/08  */


