/*
 * $Id: lex.h,v 1.1 90/12/07 11:50:43 drew Exp $
 * 
 * $Log:	lex.h,v $
# Revision 1.1  90/12/07  11:50:43  drew
# Initial revision
# 
 */

/**********************************************************************
 * Copyright 1990,1991 by University of Toronto, Toronto, Ontario, Canada.
 * 
 *			 All Rights Reserved
 * 
 * Permission to use, copy, modify, distribute, and sell this software
 * and its documentation for any purpose is hereby granted without fee, 
 * provided that the above copyright notice appears in all copies and that 
 * both the copyright notice and this permission notice appear in 
 * supporting documentation, and that the name of University of Toronto 
 * not be used in advertising or publicity pertaining to distribution 
 * of the software without specific, written prior permission.  
 * University of Toronto makes no representations about the suitability 
 * of this software for any purpose. It is provided "as is" without 
 * express or implied warranty. 
 *
 * UNIVERSITY OF TORONTO DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS 
 * SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND 
 * FITNESS, IN NO EVENT SHALL UNIVERSITY OF TORONTO BE LIABLE FOR ANY 
 * SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER 
 * RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF 
 * CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN 
 * CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 *
 **********************************************************************/

#define LEX_N_CHARS 128
#define LEX_CM 0x7F
#define LEX_TABLE (4 * LEX_N_CHARS + 2 * sizeof(int))

typedef struct LEX_STACK {
  char **arg_end;
  char *string_end;
  char *syntax;
} LEX_STACK;

extern char *LexInit();
extern char *LexReinit();
extern char *LexMem();
/* extern int *LexSetErr(); */
extern char *LexMakeSyntax();
extern char *LexSetSyntax();
extern char **LexAnalyse();	/* (lex_table,line,&tokc,0,0) */
extern char **LexAnalyseAdd();
extern char **LexAnalysePush();
extern void LexAnalysePop();

#define LEX_SP_BF_TOK	0x1
#define LEX_IS_OP	0x2
#define LexQuotedTok(s) ((s)[-2])
#define LexSpBefore(s) ((s)[-1] & LEX_SP_BF_TOK)
#define LexIsOperator(s)  ((s)[-1] & LEX_IS_OP)
