/*
 * $Id: strtod.c,v 1.1 90/12/07 11:52:54 drew Exp $
 * 
 * $Log:	strtod.c,v $
# Revision 1.1  90/12/07  11:52:54  drew
# Initial revision
# 
 */

/**********************************************************************
 * Copyright 1990,1991 by University of Toronto, Toronto, Ontario, Canada.
 * 
 *			 All Rights Reserved
 * 
 * Permission to use, copy, modify, distribute, and sell this software
 * and its documentation for any purpose is hereby granted without fee, 
 * provided that the above copyright notice appears in all copies and that 
 * both the copyright notice and this permission notice appear in 
 * supporting documentation, and that the name of University of Toronto 
 * not be used in advertising or publicity pertaining to distribution 
 * of the software without specific, written prior permission.  
 * University of Toronto makes no representations about the suitability 
 * of this software for any purpose. It is provided "as is" without 
 * express or implied warranty. 
 *
 * UNIVERSITY OF TORONTO DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS 
 * SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND 
 * FITNESS, IN NO EVENT SHALL UNIVERSITY OF TORONTO BE LIABLE FOR ANY 
 * SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER 
 * RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF 
 * CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN 
 * CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 *
 **********************************************************************/

#include <ctype.h>
#include <math.h>

extern long strtol();

/***
 * strtod(str, ptr) - parse a floating point number
 * [-]  <long>[.<long>]e(+/-)<long>
 * this is needed on hebb - doesn't define it
 */
double strtod(str, ptr)
char *str;
char **ptr;
{
  long integer;
  long exponent;
  double result;
  char *s;
  char *p = str;
  long val;
  int sign = 1, exp_sign = 1;

  if (*p == '-')
    sign = -1;
  integer = strtol(p, &p, 10);
  if (p==str && *p!='.') {
    *ptr = str;
    return 0.0;
  }
  result = integer;
  if (*p=='.') {
    double fraction;
    str = p+1;
    fraction = strtol(str, &p, 10);
    for (str; str<p; str++)
      fraction /= 10.0;
    if (result>=0 && sign>0)
      result += fraction;
    else
      result -= fraction;
  }
  if (*p=='e' || *p=='E') {
    str = p+1;
    if (*str=='+') {
      str++;
    } else if (*str=='-') {
      exp_sign = -1;
      str++;
    }
    exponent = strtol(str, &p, 10);
    result *= pow(10.0, (double)exp_sign*exponent);
  }
  *ptr = p;
  return result;
}
