/*
 * $Id: stream.h,v 1.1 90/12/07 11:51:06 drew Exp $
 * 
 * $Log:	stream.h,v $
# Revision 1.1  90/12/07  11:51:06  drew
# Initial revision
# 
 */

/**********************************************************************
 * Copyright 1990,1991 by University of Toronto, Toronto, Ontario, Canada.
 * 
 *			 All Rights Reserved
 * 
 * Permission to use, copy, modify, distribute, and sell this software
 * and its documentation for any purpose is hereby granted without fee, 
 * provided that the above copyright notice appears in all copies and that 
 * both the copyright notice and this permission notice appear in 
 * supporting documentation, and that the name of University of Toronto 
 * not be used in advertising or publicity pertaining to distribution 
 * of the software without specific, written prior permission.  
 * University of Toronto makes no representations about the suitability 
 * of this software for any purpose. It is provided "as is" without 
 * express or implied warranty. 
 *
 * UNIVERSITY OF TORONTO DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS 
 * SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND 
 * FITNESS, IN NO EVENT SHALL UNIVERSITY OF TORONTO BE LIABLE FOR ANY 
 * SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER 
 * RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF 
 * CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN 
 * CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 *
 **********************************************************************/

typedef enum STREAM_STATUS {
  STREAM_STATUS_XX,
  STREAM_ERROR,
  STREAM_OPEN,
  STREAM_CLOSED,
};

typedef enum STREAM_TYPE {
  STREAM_TYPE_XX,
  STREAM_FILE,
  STREAM_APPEND,
  STREAM_REMOTE_FILE,
  STREAM_REMOTE_APPEND,
  STREAM_SOCKET,
  STREAM_PORT,
  STREAM_COMMAND,
};

typedef struct STREAM {
  FILE	*file;
  char	*desc;
  char	*name;
  char	*machine;	/* used for the remote file stuff */
  enum STREAM_TYPE	type;
  enum STREAM_STATUS	status;
  int	port;		/* the port we should try to open */
  int	real_port;	/* the actual port we have open */
  int	search;		/* boolean: search for a port which will accept */
  int	permanent;	/* =1 if this should stay open across commands */
  struct STREAM *next;	/* keep streams in a linked list */
  struct BLOT_RECORD	blot;
  char *mode;
};

extern struct STREAM *current_instream,*current_outstream;
extern struct STREAM *stdin_stream,*stdout_stream;  /* permanent std streams */
extern struct STREAM *command_stdin,*command_stdout; /* command std streams */
extern void IEndRedirection();
