/*
 * $Id: build-linkset.c,v 1.1 90/12/07 12:00:30 drew Exp $
 * 
 * $Log:	build-linkset.c,v $
 * Revision 1.1  90/12/07  12:00:30  drew
 * Initial revision
 * 
 */

/**********************************************************************
 * Copyright 1990,1991 by University of Toronto, Toronto, Ontario, Canada.
 * 
 *			 All Rights Reserved
 * 
 * Permission to use, copy, modify, distribute, and sell this software
 * and its documentation for any purpose is hereby granted without fee, 
 * provided that the above copyright notice appears in all copies and that 
 * both the copyright notice and this permission notice appear in 
 * supporting documentation, and that the name of University of Toronto 
 * not be used in advertising or publicity pertaining to distribution 
 * of the software without specific, written prior permission.  
 * University of Toronto makes no representations about the suitability 
 * of this software for any purpose. It is provided "as is" without 
 * express or implied warranty. 
 *
 * UNIVERSITY OF TORONTO DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS 
 * SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND 
 * FITNESS, IN NO EVENT SHALL UNIVERSITY OF TORONTO BE LIABLE FOR ANY 
 * SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER 
 * RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF 
 * CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN 
 * CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 *
 **********************************************************************/

#include <itf/itf.h>
#include "sim-dummy.h"
#include <sim.h>

  /*
info = layer->info+unit_n;
  if (   (mode & UNI_DIRECTIONAL)
      || ((mode & BI_DIRECTIONAL) && !same_layer))
    n_links_in_this_set = n_links;
  else
    if (mode & RECURRENT_LINKS)
      n_links_in_this_set = unit_n + 1;
    else
      n_links_in_this_set = unit_n;
  if (n_links_in_this_set<=0) continue;

  *** call here ***

  link_vector += n_links * sizeof_link[link_tag];
  if (link_sets!=NULL) link_sets[unit_n] = link_set;
  */

/***
 * Build a linkset for a particular unit
 */
LINK_SET *BuildLinkSet(s_net,s_layer,info,n_links,mode,link_vector,link_tag,connectivity)
int s_net;
int s_layer;
UNIT_INFO *info;
int n_links;
int mode;
char *link_vector;	/* use this for the links rather than allocating */
int link_tag;
int connectivity;
{
  int i;
  LINK_SET *link_set;
  /***
   * make another link set and put it at the end of the list
   */
  link_set = Calloc(LINK_SET,1);
  if (link_set==NULL) {
    warn("Connect_","out of memory for dest link sets, requested %d",
	 sizeof(LINK_SET));
    return NULL;
  }
  n_links_built += n_links;
  link_set->connect_layer = s_layer;
  link_set->connect_net = s_net;
  link_set->mode = INWARD | connectivity | LINK_VECTOR;
  if (mode & BI_DIRECTIONAL) link_set->mode |= BI_DIRECTIONAL;
  link_set->starting_unit_n = 0;
  link_set->n_links = n_links;
  link_set->stride = 1;
  link_set->unit_id = NULL;
  link_set->link_tag = link_tag;
  AddLinkSet(info,link_set,-1);
  /***
   * need a vector of links - get it from the matrix, or allocate it
   */
  if (link_vector!=NULL) {
    link_set->l.p = (LINK_PTR)link_vector;
  } else { /* have to allocate */
    link_set->l.p =
      (LINK_PTR)calloc(n_links,sizeof_link[link_tag]);
    if (link_set->l.p==NULL) {
      warn("Connect_","out of memory for links (requested %d * %d)",
	   n_links,sizeof_link[link_tag]);
      return NULL;
    }
  }
  /***
   * allocate the vector of unit-id's, if necessary
   */
  if (mode & CONNECT_PARTIAL) {
    link_set->unit_id = Calloc(short,n_links);
    if (link_set->unit_id==NULL) {
      warn("Connect_","out of memory for link id's (requested %d * %d)",
	   n_links,sizeof(short));
      return NULL;
    }
    for (i=0;i<n_links;i++)
      link_set->unit_id[i] = i+link_set->starting_unit_n;
  }
  return link_set;
}
