/*
 * $Id: find-link.h,v 1.1 90/12/07 12:00:45 drew Exp $
 * 
 * $Log:	find-link.h,v $
 * Revision 1.1  90/12/07  12:00:45  drew
 * Initial revision
 * 
 */

/**********************************************************************
 * Copyright 1990,1991 by University of Toronto, Toronto, Ontario, Canada.
 * 
 *			 All Rights Reserved
 * 
 * Permission to use, copy, modify, distribute, and sell this software
 * and its documentation for any purpose is hereby granted without fee, 
 * provided that the above copyright notice appears in all copies and that 
 * both the copyright notice and this permission notice appear in 
 * supporting documentation, and that the name of University of Toronto 
 * not be used in advertising or publicity pertaining to distribution 
 * of the software without specific, written prior permission.  
 * University of Toronto makes no representations about the suitability 
 * of this software for any purpose. It is provided "as is" without 
 * express or implied warranty. 
 *
 * UNIVERSITY OF TORONTO DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS 
 * SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND 
 * FITNESS, IN NO EVENT SHALL UNIVERSITY OF TORONTO BE LIABLE FOR ANY 
 * SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER 
 * RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF 
 * CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN 
 * CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 *
 **********************************************************************/

#ifndef _FIND_LINK_
#define _FIND_LINK_

/* DoFind stuff can't handle linksets with random addressing (i.e., using unit_id vector */

#define DoFindLayerLinkSet(LINK_TYPE, OTHER_UNIT_TYPE, CONNECT_LAYER, CONNECT_UNIT) \
  {\
    LINK_SET*ls=NULL;\
    int ls_n;\
    LINK_TYPE*link=NULL;\
    LINK_TYPE**link_vector=NULL;\
    LINK_TYPE*link0=NULL;\
    OTHER_UNIT_TYPE*other=NULL;\
    OTHER_UNIT_TYPE*other0=NULL;\
    short link_tag=TAG(LINK_TYPE);\
    short unit_tag=TAG(OTHER_UNIT_TYPE);\
    short link_n;\
    short *other_unit_n=NULL;\
    short connect_unit=(CONNECT_UNIT);\
    short connect_layer=(CONNECT_LAYER);\
    ls_n=0;\
    for (ls_n=0; ls_n<info->n_lss; ls_n++) {\
      ls = info->ls[ls_n];\
      if (   ls->link_tag==link_tag\
          && ls->connect_layer==connect_layer\
	  && ls->connect_net==net->my_n\
          && neta[ls->connect_net]->layer[connect_layer].unit_tag==unit_tag\
	  && ls->unit_id==NULL\
          && connect_unit>=ls->starting_unit_n\
          && connect_unit<ls->starting_unit_n+ls->n_links)\
        break;\
    }\
    if (ls_n>=info->n_lss)\
      IErrorAbort("DoFindLayerLinkSet: can't find linkset for unit %d:%d that connects to %d:%d", layer_n, unit_n, connect_layer, connect_unit);\
    other = CONCAT(UNIT_PTR_,OTHER_UNIT_TYPE)(neta[ls->connect_net]->layer[ls->connect_layer].unit);\
    other0 = CONCAT(UNIT_PTR_,OTHER_UNIT_TYPE)(neta[ls->connect_net]->layer[ls->connect_layer].unit);\
    link_n = 0;\
    other_unit_n = ls->unit_id;\
    if (ls->mode&CONNECT_BLOCK)\
      other0 += ls->starting_unit_n;\
    if (ls->mode&LINK_VECTOR){\
      link = CONCAT(LINK_PTR_,LINK_TYPE)(ls->l.p);\
      link0 = CONCAT(LINK_PTR_,LINK_TYPE)(ls->l.p);\
    } else {\
      link_vector = (LINK_TYPE**)(ls->l.pp);\
      link = link_vector[0];\
    }

#define LinkSetLinksToUnit(CONNECT_UNIT) \
   (   ls->unit_id==NULL\
    && connect_unit>=ls->starting_unit_n\
    && connect_unit<ls->starting_unit_n+ls->n_links)

#define AbortWithCantFindUnitMessage \
    IErrorAbort("DoFindUnitLink: doing unit %d:%d, link to %d:%d is not in linkset found by DoFindLayerLinkSet (%d:%d-%d)", layer_n, unit_n, connect_layer, ls->starting_unit_n, ls->starting_unit_n+ls->n_links-1)\
      
#define DoFindUnitLink(CONNECT_UNIT) \
    {\
      connect_unit = (CONNECT_UNIT);\
      link_n = (connect_unit - ls->starting_unit_n);\
      other = other0 + link_n;\
      if (ls->mode&LINK_VECTOR) {\
        link = link0 + link_n;\
      } else {\
        link = link_vector[link_n];\
      }

#endif _FIND_LINK_
