/*
 * $Id: test-ieee.c,v 1.1 90/12/07 12:01:20 drew Exp $
 * 
 * $Log:	test-ieee.c,v $
 * Revision 1.1  90/12/07  12:01:20  drew
 * Initial revision
 * 
 */

/**********************************************************************
 * Copyright 1990,1991 by University of Toronto, Toronto, Ontario, Canada.
 * 
 *			 All Rights Reserved
 * 
 * Permission to use, copy, modify, distribute, and sell this software
 * and its documentation for any purpose is hereby granted without fee, 
 * provided that the above copyright notice appears in all copies and that 
 * both the copyright notice and this permission notice appear in 
 * supporting documentation, and that the name of University of Toronto 
 * not be used in advertising or publicity pertaining to distribution 
 * of the software without specific, written prior permission.  
 * University of Toronto makes no representations about the suitability 
 * of this software for any purpose. It is provided "as is" without 
 * express or implied warranty. 
 *
 * UNIVERSITY OF TORONTO DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS 
 * SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND 
 * FITNESS, IN NO EVENT SHALL UNIVERSITY OF TORONTO BE LIABLE FOR ANY 
 * SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER 
 * RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF 
 * CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN 
 * CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 *
 **********************************************************************/

#include <itf/itf.h>
#include "sim-dummy.h"
#include "sim-math.h"
#include <sim.h>
#include <stdio.h>

int sizeof_real = sizeof(real);

main()
{
  float fx;
  double dx;
  print_defs();
  fx = calc_quiet_nan(0L);
  dx = calc_quiet_nan(0L);
  /***
   * All of these things that are printed out are checked for
   * in autoinit_math().  They's just printed out so yo can
   * see what's happ'nin.
   */
  printf("float nan = %g (should be NaN) 0x%X\n",fx,fx);
  printf("double nan = %g (should be NaN) 0x%X 0x%X\n",dx,dx);
  printf("isnan(float nan) = %d (should be 1)\n",isnan(fx));
  printf("isnan(double nan) = %d (should be 1)\n",isnan(dx));
  printf("isinf(float nan) = %d (can be 0 or 1)\n",isinf(fx));
  printf("isinf(double nan) = %d (can be 0 or 1)\n",isinf(dx));
#ifndef NO_GEN_INFINITY
  fx = calc_infinity();
  dx = calc_infinity();
  printf("float inf = %g (should be Inf or Infinity) 0x%X\n",fx,fx);
  printf("double inf = %g (should be Inf) 0x%X 0x%X\n",dx,dx);
  printf("float -inf = %g (should be -Inf)\n",-fx);
  printf("double -inf = %g (should be -Inf)\n",-dx);
  printf("isinf(float inf) = %d (should be 1)\n",isinf(fx));
  printf("isinf(double inf) = %d (should be 1)\n",isinf(dx));
  printf("isnan(float inf) = %d (can be 0 or 1)\n",isnan(fx));
  printf("isnan(double inf) = %d (can be 0 or 1)\n",isnan(dx));
#else
  printf("\nNo infinity value is defined for this system at all.\n");
#endif NO_GEN_INFINITY
  printf("\nIf any of the above were incorrect, they will be detected\n");
  printf("by the following call to autoinit_math()\n");
  printf("If nothing further is printed, all is ok\n");
  autoinit_math();
}

print_defs()
{
#ifdef NO_GEN_INFINITY
  printf("NO_GEN_INFINITY defined\n");
#else
  printf("NO_GEN_INFINITY not defined\n");
#endif NO_GEN_INFINITY
#ifdef NO_GEN_NAN
  printf("NO_GEN_NAN defined\n");
#else
  printf("NO_GEN_NAN not defined\n");
#endif NO_GEN_NAN
#ifdef NO_BUILT_IN_INFINITY
  printf("NO_BUILT_IN_INFINITY defined\n");
#else
  printf("NO_BUILT_IN_INFINITY not defined\n");
#endif NO_BUILT_IN_INFINITY
#ifdef NO_BUILT_IN_QUIET_NAN
  printf("NO_BUILT_IN_QUIET_NAN defined\n");
#else
  printf("NO_BUILT_IN_QUIET_NAN not defined\n");
#endif NO_BUILT_IN_QUIET_NAN
}
