/*
 * $Id: traverse.h,v 1.1 90/12/07 12:01:27 drew Exp $
 * 
 * $Log:	traverse.h,v $
 * Revision 1.1  90/12/07  12:01:27  drew
 * Initial revision
 * 
 */

/**********************************************************************
 * Copyright 1990,1991 by University of Toronto, Toronto, Ontario, Canada.
 * 
 *			 All Rights Reserved
 * 
 * Permission to use, copy, modify, distribute, and sell this software
 * and its documentation for any purpose is hereby granted without fee, 
 * provided that the above copyright notice appears in all copies and that 
 * both the copyright notice and this permission notice appear in 
 * supporting documentation, and that the name of University of Toronto 
 * not be used in advertising or publicity pertaining to distribution 
 * of the software without specific, written prior permission.  
 * University of Toronto makes no representations about the suitability 
 * of this software for any purpose. It is provided "as is" without 
 * express or implied warranty. 
 *
 * UNIVERSITY OF TORONTO DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS 
 * SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND 
 * FITNESS, IN NO EVENT SHALL UNIVERSITY OF TORONTO BE LIABLE FOR ANY 
 * SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER 
 * RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF 
 * CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN 
 * CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 *
 **********************************************************************/

#ifdef lint
#define NOLINT(X)
#else
#define NOLINT(X) X
#endif
#define ForEachNetwork \
  {\
    int		net_n;\
    struct NETWORK	*tnet;\
    for (net_n=0;net_n<n_nets;net_n++) if ((tnet=neta[net_n])!=NULL) {

#define ForEachLayer \
  {\
    struct LAYER	*layer;\
    struct LAYER_PARAMS	*lp=NULL;\
    int		layer_n;\
    for ((layer_n=0), (layer=net->layer);\
	 layer_n<net->n_layers;\
	 (layer_n++, layer++)) {lp = layer->p;

#define ForEachLayerType(UNIT_TYPE) \
  {\
    struct LAYER	*layer;\
    struct LAYER_PARAMS	*lp=NULL;\
    int		layer_n;\
    for ((layer_n=0), (layer=net->layer);\
	 layer_n<net->n_layers;\
	 (layer_n++, layer++))\
      if (layer->unit_tag==TAG(UNIT_TYPE)) {lp = layer->p;

#define ForEachLayerDown \
  {\
    struct LAYER	*layer;\
    struct LAYER_PARAMS	*lp=NULL;\
    int		layer_n;\
    for ((layer_n=net->n_layers-1), (layer=net->layer+net->n_layers-1);\
	 layer_n>=0;\
	 (layer_n--, layer--)) {lp = layer->p;

#define ForEachLayerDownType(UNIT_TYPE) \
  {\
    struct LAYER	*layer;\
    struct LAYER_PARAMS	*lp=NULL;\
    int		layer_n;\
    for ((layer_n=net->n_layers-1), (layer=net->layer+net->n_layers-1);\
	 layer_n>=0;\
	 (layer_n--, layer--))\
      if (layer->unit_tag==TAG(UNIT_TYPE)) {lp = layer->p;

#define ForEachUnit(UNIT_TYPE) \
  {\
    UNIT_INFO	*info;\
    UNIT_TYPE	*unit;\
    int		unit_n;\
    assertm(layer->unit_tag==TAG(UNIT_TYPE), "bad unit type");\
    for ((unit_n=0), (unit=CONCAT(UNIT_PTR_,UNIT_TYPE)(layer->unit)), \
	          (info=layer->info);\
	 unit_n<layer->n_units;\
	 unit_n++, unit++, info++) {

#define ForEachUnitGeneric \
  {\
    UNIT_INFO	*info;\
    char	*unit;\
    int		unit_n;\
    for ((unit_n=0), (unit=FIRST_UNIT(layer)), (info=layer->info);\
	 unit_n<layer->n_units;\
	 unit_n++, unit+=sizeof_unit[layer->unit_tag], info++) {

#define FirstUnit(UNIT_TYPE, LAYER_N) \
  ((UNIT_TYPE*)FIRST_UNIT((net->layer+(LAYER_N))))

#define ForEachOtherUnit(UNIT_TYPE) \
  {\
    UNIT_INFO	*other_info;\
    UNIT_TYPE	*other;\
    int		other_n;\
    assertm(layer->unit_tag==TAG(UNIT_TYPE), "bad unit type");\
    for ((other_n=0), (other=CONCAT(UNIT_PTR_,UNIT_TYPE)(layer->unit)), \
	          (other_info=layer->info);\
	 other_n<layer->n_units;\
	 other_n++, other++, other_info++) {

#define ForEachUnitInfo \
  {\
    UNIT_INFO	*info;\
    int		unit_n;\
    for ((unit_n=0), (info=layer->info);\
	 unit_n<layer->n_units;\
	 unit_n++, info++) {

#define DoLayer(N) \
  {\
    LAYER	*layer = net->layer + N;\
    int		layer_n = N;\
    assertm(N < net->n_layers, "layer out of range");

#define DoLayerUnit(N, UNIT_TYPE, M) \
  {\
    LAYER	*layer = net->layer + N;\
    UNIT_INFO	*info;\
    UNIT_TYPE	*unit;\
    int		unit_n;\
    int		layer_n = N;\
    assertm(N < net->n_layers, "layer out of range");\
    assertm(layer->unit_tag==TAG(UNIT_TYPE), "bad unit type");\
    assertm(NOLINT(M >= 0 &&) M < layer->n_units, "unit # out of range");\
    unit_n = M;\
    unit = (unit=CONCAT(UNIT_PTR_,UNIT_TYPE)(layer->unit))+unit_n;\
    info = layer->info+unit_n;
   
#define DoUnit(UNIT_TYPE, N) \
  {\
    UNIT_INFO	*info;\
    UNIT_TYPE	*unit;\
    int		unit_n;\
    assertm(layer->unit_tag==TAG(UNIT_TYPE), "bad unit type");\
    assertm(NOLINT(N >=0 &&) N < layer->n_units, "unit # out of range");\
    unit_n = N;\
    unit = (unit=CONCAT(UNIT_PTR_,UNIT_TYPE)(layer->unit))+unit_n;\
    info = layer->info+unit_n;

#define DoUnitGeneric(N) \
  {\
    UNIT_INFO	*info;\
    int		unit_n;\
    char	*unit;\
    assertm(NOLINT(N >=0 &&) N < layer->n_units, "unit # out of range");\
    unit_n = N;\
    unit = FIRST_UNIT(layer)+unit_n*sizeof_unit[layer->unit_tag];\
    info = layer->info+unit_n;

#define NextUnit(N) \
  {\
    unit_n = N;\
    unit = (unit=CONCAT(UNIT_PTR_,UNIT_TYPE)(layer->unit))+unit_n;\
    info = layer->info+unit_n;}

#define ForEachLinkSet(LINK_TYPE, OTHER_UNIT_TYPE) \
  {\
    LINK_SET*ls=NULL;\
    int ls_n;\
    LINK_TYPE*link=NULL;\
    LINK_TYPE*link0=NULL;\
    LINK_TYPE**link_vector=NULL;\
    OTHER_UNIT_TYPE*other=NULL;\
    OTHER_UNIT_TYPE*other0=NULL;\
    LAYER_PARAMS*olp=NULL;\
    short link_n;\
    short *other_unit_n=NULL;\
    if (info->n_lss>0)\
    for (ls = info->ls[ls_n=0];ls_n<info->n_lss;ls=info->ls[++ls_n])\
      if (   ls->link_tag==TAG(LINK_TYPE)\
	  && neta[ls->connect_net]->layer[ls->connect_layer].unit_tag==TAG(OTHER_UNIT_TYPE)\
	  && (!ls->deactivate || inhibit_deactivate)) {\
        other0 = CONCAT(UNIT_PTR_,OTHER_UNIT_TYPE)(neta[ls->connect_net]->layer[ls->connect_layer].unit);\
        olp = neta[ls->connect_net]->layer[ls->connect_layer].p;\
	if (ls->mode&CONNECT_BLOCK)\
          other0 += ls->starting_unit_n;\
	if (ls->mode&LINK_VECTOR)\
          link0 = CONCAT(LINK_PTR_,LINK_TYPE)(ls->l.p);\
	else {\
	  link_vector = (LINK_TYPE**)(ls->l.pp);\
	}

#define DoLinkset(LINK_TYPE, OTHER_UNIT_TYPE, N) \
  {\
    LAYER_PARAMS*olp=NULL;\
    LINK_SET*ls=NULL;\
    int ls_n;\
    LINK_TYPE*link=NULL;\
    LINK_TYPE**link_vector=NULL;\
    LINK_TYPE*link0=NULL;\
    OTHER_UNIT_TYPE*other=NULL;\
    OTHER_UNIT_TYPE*other0=NULL;\
    short link_n;\
    short *other_unit_n=NULL;\
    if (info->n_lss>0) ls = info->ls[ls_n=N];\
    assertm(ls->link_tag==TAG(LINK_TYPE), "bad link type");\
    assertm(neta[ls->connect_net]->layer[ls->connect_layer].unit_tag==TAG(OTHER_UNIT_TYPE), "bad other unit type");\
    other = CONCAT(UNIT_PTR_,OTHER_UNIT_TYPE)(neta[ls->connect_net]->layer[ls->connect_layer].unit);\
    other0 = CONCAT(UNIT_PTR_,OTHER_UNIT_TYPE)(neta[ls->connect_net]->layer[ls->connect_layer].unit);\
    link_n = 0;\
    other_unit_n = ls->unit_id;\
    olp = neta[ls->connect_net]->layer[ls->connect_layer].p;\
    if (ls->mode&CONNECT_BLOCK) other0 += ls->starting_unit_n;\
    if (ls->mode&LINK_VECTOR){\
      link = CONCAT(LINK_PTR_,LINK_TYPE)(ls->l.p);\
      link0 = CONCAT(LINK_PTR_,LINK_TYPE)(ls->l.p);}\
    else {\
      link_vector = (LINK_TYPE**)(ls->l.pp);\
      link = link_vector[0];\
    }

#define ApplyToEachLink(P) \
  {\
    other = other0;\
    link_n = 0;\
    other_unit_n = ls->unit_id;\
    if (ls->mode&LINK_VECTOR) { /* Link Vector */ \
        link = link0;\
	if (ls->mode&(CONNECT_COMPLETE|CONNECT_BLOCK)) /* Contiguous */ \
          for (;link_n<ls->n_links;link_n++, link++, other++) {P}\
	else { /* Partial */ \
          for (;link_n<ls->n_links;link_n++, link++, other_unit_n++) {\
	    other = other0 + *other_unit_n;\
	    P\
	  }\
	}\
    } else if (   (ls->mode&LINK_POINTER_VECTOR)\
	     && (ls->mode&(CONNECT_COMPLETE|CONNECT_BLOCK))) { /* Link Pointer Vector */ \
      link=link_vector[link_n];\
      for (;link_n<ls->n_links;link_n++, (link=link_vector[link_n]), other++) {P}\
    } else panic("ApplyToEachLink", "unknown link mode");\
  }

#define DoLink(M) \
  { \
    int i; \
    link_n=M; \
    other = other0;\
    other_unit_n = ls->unit_id;\
    if (ls->mode&LINK_VECTOR) {\
      link = link0;\
      if (ls->mode&(CONNECT_COMPLETE|CONNECT_BLOCK)) {\
        for (i=0; i<link_n; i++) { \
	  link++;\
          other++;\
        }\
      } else {\
        for (i=0; i<link_n; i++) {\
	  link++;\
	  other++;\
	  other_unit_n++;\
	}\
      }\
    } else if ((ls->mode&LINK_POINTER_VECTOR)\
	       && (ls->mode&(CONNECT_COMPLETE|CONNECT_BLOCK))) {\
      for (i=0; i<link_n; i++) {\
        other++;\
      }\
      link=link_vector[link_n];\
    }

#define ForEachLinkSetGeneric \
  {\
    LINK_SET*ls=NULL;\
    int ls_n;\
    generic*link=NULL;\
    generic*link0=NULL;\
    generic**link_vector=NULL;\
    short link_n;\
    short *other_unit_n=NULL;\
    if (info->n_lss>0)\
    for (ls = info->ls[ls_n=0];ls_n<info->n_lss;ls=info->ls[++ls_n]) \
      if (!ls->deactivate || inhibit_deactivate) {\
	if (ls->mode&LINK_VECTOR)\
          link0 = ls->l.cp;\
	else {\
	  link_vector = ls->l.cpp;\
	}

#define DoLinkSetGeneric(M) \
  {\
    LINK_SET*ls=NULL;\
    int ls_n=M;\
    generic*link=NULL;\
    generic**link_vector=NULL;\
    short link_n;\
    short *other_unit_n=NULL;\
        ls = info->ls[ls_n]; \
	link_n = 0;\
        other_unit_n = ls->unit_id;\
	if (ls->mode&LINK_VECTOR)\
          link = ls->l.cp;\
	else {\
	  link_vector = ls->l.cpp;\
          link = link_vector[0];\
	}

#define ApplyToEachLinkGeneric(P) \
  {\
    link_n = 0;\
    other_unit_n = ls->unit_id;\
    if (ls->mode&LINK_VECTOR) {\
      link = link0;\
      if (ls->mode&(CONNECT_COMPLETE|CONNECT_BLOCK))\
        for (;link_n<ls->n_links;link_n++, \
	       link+=sizeof_link[ls->link_tag]) {P}\
      else {\
        for (;link_n<ls->n_links;link_n++, \
	       link+=sizeof_link[ls->link_tag], other_unit_n++) {P}\
      }\
    } else if (   (ls->mode&LINK_POINTER_VECTOR)\
	     && (ls->mode&(CONNECT_COMPLETE|CONNECT_BLOCK))) {\
      link=link_vector[link_n];\
      for (;link_n<ls->n_links;link_n++, (link=link_vector[link_n])) {P}\
    } else panic("ApplyToEachLinkGeneric", "unknown link mode");\
  }

#define DoLinkGeneric(M) \
   { \
    int i; \
    link_n=M; \
    if (ls->mode&LINK_VECTOR) { \
	if (ls->mode&(CONNECT_COMPLETE|CONNECT_BLOCK)) { \
	  for (i=0; i<link_n; i++) { \
	    link++; } \
	} else { \
	  for (i=0; i<link_n; i++) { \
	    link++; } \
	 } \
    } else if ((ls->mode&LINK_POINTER_VECTOR)\
	     && (ls->mode&(CONNECT_COMPLETE|CONNECT_BLOCK))) \
	       { \
                 link=link_vector[link_n]; }

#define ForEachLinkSetAnyType \
  {\
    LINK_SET*ls;\
    int ls_n;\
    for (ls_n = 0; ls_n<info->n_lss; ls_n++) {\
      ls = info->ls[ls_n];

#define ApplyToLinks(P) ApplyToEachLink(P)

#define ApplyToLinksOfUnit(LINK_TYPE, OTHER_UNIT_TYPE, P) \
  ForEachLinkSet(LINK_TYPE,OTHER_UNIT_TYPE)\
    ApplyToEachLink(P)\
  EndForEach

#define ApplyToLinksOfLayer(UNIT_TYPE, LINK_TYPE, OTHER_UNIT_TYPE, P) \
  ForEachUnit(UNIT_TYPE)\
    ApplyToLinksOfUnit(LINK_TYPE,OTHER_UNIT_TYPE, P)\
  EndForEach

#define ApplyToLinksOfNet(UNIT_TYPE, LINK_TYPE, OTHER_UNIT_TYPE, P) \
  ForEachLayerType(UNIT_TYPE)\
    ApplyToLinksOfLayer(UNIT_TYPE,LINK_TYPE,OTHER_UNIT_TYPE, P)\
  EndForEach

#define ApplyToLinksOfNetUnique(UNIT_TYPE, LINK_TYPE, OTHER_UNIT_TYPE, P) \
  ForEachLayerType(UNIT_TYPE)\
    ForEachUnit(UNIT_TYPE)\
      ForEachLinkSet(LINK_TYPE,OTHER_UNIT_TYPE)\
	if (!(ls->mode&PARASITIC) && !(ls->mode&OUTWARD))\
          ApplyToEachLink(P)\
      EndForEach\
    EndForEach\
  EndForEach

#define ApplyToUnitsOfNet(UNIT_TYPE, P) \
  ForEachLayerType(UNIT_TYPE)\
    ForEachUnit(UNIT_TYPE)\
      P\
    EndForEach\
  EndForEach
    

#define EndForEach	}}
#define EndDo		}

#define OtherUnitN (other_unit_n==NULL ? link_n+ls->starting_unit_n : *other_unit_n)

#define SetSourceUnit(N) \
    {\
      assertm(other_unit_n!=NULL, "SetSourceUnit called for link not created with partial connectivity");\
      *other_unit_n = N;\
      other = other0 + N;\
    }

#define SetSourceUnitGeneric(N) \
    {\
      assertm(other_unit_n!=NULL, "SetSourceUnit called for link not created with partial connectivity");\
      *other_unit_n = N;\
    }

#define OtherLayerN (ls->connect_layer)

#define OtherNetN (ls->connect_net)

#define SetBlockStart(N) {assertm(!(ls->mode&BI_DIRECTIONAL), "can't set block start for bidirectional links");ls->starting_unit_n = (N);}

#define IsDestSet (ls->mode&INWARD)
#define IsBidirSet (ls->mode&BI_DIRECTIONAL)
#define IsSourceSet (!IsDestSet)
#define IsIncomingLink IsDestSet

#define PrintLinkLocation(file) \
    fprintf(file, "%d:%d%s%d:%d", \
	    OtherLayerN, OtherUnitN, (IsDestSet ? "-->" : "<--"), \
	    layer_n, unit_n, link_n);

#define LinkLocation \
   (sprintf(sim_buf, "%d:%d%s%d:%d", \
	    OtherLayerN, OtherUnitN, (IsDestSet ? "-->" : "<--"), \
	    layer_n, unit_n, link_n), sim_buf)
/***
 * still TODO: below
#define ForEachLinkMainSet		{LINK_SET*ls, *lms;LINK_PTR*link;UNIT_PTR*other;for (;;) {
#define ForEachLinkSubSet		{for (;;) {
 */

#define LayerFormat(n) (&(net->layer[n].format))
#define LayerParams(n) (net->layer[n].p)
#define UnitPointer(layer_n, UNIT_TYPE) \
     (CONCAT(UNIT_PTR_,UNIT_TYPE)(net->layer[layer_n].unit))
