/*
 * $Id: client1.c,v 1.1 90/12/07 12:05:01 drew Exp $
 * 
 * $Log:	client1.c,v $
# Revision 1.1  90/12/07  12:05:01  drew
# Initial revision
# 
 */

/**********************************************************************
 * Copyright 1990,1991 by University of Toronto, Toronto, Ontario, Canada.
 * 
 *			 All Rights Reserved
 * 
 * Permission to use, copy, modify, distribute, and sell this software
 * and its documentation for any purpose is hereby granted without fee, 
 * provided that the above copyright notice appears in all copies and that 
 * both the copyright notice and this permission notice appear in 
 * supporting documentation, and that the name of University of Toronto 
 * not be used in advertising or publicity pertaining to distribution 
 * of the software without specific, written prior permission.  
 * University of Toronto makes no representations about the suitability 
 * of this software for any purpose. It is provided "as is" without 
 * express or implied warranty. 
 *
 * UNIVERSITY OF TORONTO DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS 
 * SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND 
 * FITNESS, IN NO EVENT SHALL UNIVERSITY OF TORONTO BE LIABLE FOR ANY 
 * SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER 
 * RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF 
 * CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN 
 * CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 *
 **********************************************************************/


/*
Here's a shar file containing sample client/server programs.
The client part is straightforward.  The server code will
run under inetd if compiled -DINETD, otherwise it will run standalone.
I think it's best to use a standalone server for now.
That way you are in complete control of things.  Also if you run
under inetd, a couple of system data files have to be updated and inetd
has to be restarted, which you can't do yourself.

Anyway you'll have to modify your server code so that
in its main loop it also selects on ``s'' (the server socket
file descriptor -- not the best variable name...).  All that should
take is another FD_SET call.  Also be sure that the first argument
to select() is correct after this change.  If select indicates
that ``s'' is readable, there is a pending new connection,
and you should call accept() as done below.  If you want to service
one connection at a time, don't bother forking after accept().

If you run into problems, let me know.
*/

#include <stdio.h>
#include <netdb.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include "all.h"
#include "system.h"

#include "packet_struct.c"

/*
 * Connect to PORT on this machine, and copy whatever the
 * server sends to stdout.
 */
main()
{
	int s, c;
 	FILE *fp;
        int n;
        int i,j;
        char d[10];
        char f[1];
 
 	/* "localhost" is always an alias for the current machine */
 	if ((s = open_remote_stream("localhost")) < 0)
 		exit(1);
 	/* `s'' can be read or written to, using read or write. */


        for (;;) {

	f[0] = getchar();
        write(s, f, sizeof (char)); 
 
        }



 }
 
 /*
  * Open a stream connection to the PORT service on ``host'',
  * returning the file descriptor or -1.
  */
 int
 open_remote_stream(host)
 	char *host;
 {
 	struct hostent *hp;
 	struct sockaddr_in sin;
 	int s;
 
 	if ((hp = gethostbyname(host)) == NULL) {
 		fprintf(stderr, "%s: unknown host\n", host);
 		return -1;
 	}
 	bzero((char *)&sin, sizeof sin);
 	bcopy(hp->h_addr, (char *)&sin.sin_addr, hp->h_length);
 	sin.sin_family = AF_INET;
 	sin.sin_port = htons(PORT);
 	if ((s = socket(AF_INET, SOCK_STREAM, 0)) < 0) {
 		perror("socket");
 		return -1;
 	}
 	if (connect(s, (char *)&sin, sizeof sin) < 0) {
 		perror("connect");
 		close(s);
 		return -1;
 	}
 	return s;
 }
