/*
 * $Id: fred.c,v 1.1 90/12/07 12:05:05 drew Exp $
 * 
 * $Log:	fred.c,v $
# Revision 1.1  90/12/07  12:05:05  drew
# Initial revision
# 
 */

/**********************************************************************
 * Copyright 1990,1991 by University of Toronto, Toronto, Ontario, Canada.
 * 
 *			 All Rights Reserved
 * 
 * Permission to use, copy, modify, distribute, and sell this software
 * and its documentation for any purpose is hereby granted without fee, 
 * provided that the above copyright notice appears in all copies and that 
 * both the copyright notice and this permission notice appear in 
 * supporting documentation, and that the name of University of Toronto 
 * not be used in advertising or publicity pertaining to distribution 
 * of the software without specific, written prior permission.  
 * University of Toronto makes no representations about the suitability 
 * of this software for any purpose. It is provided "as is" without 
 * express or implied warranty. 
 *
 * UNIVERSITY OF TORONTO DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS 
 * SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND 
 * FITNESS, IN NO EVENT SHALL UNIVERSITY OF TORONTO BE LIABLE FOR ANY 
 * SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER 
 * RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF 
 * CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN 
 * CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 *
 **********************************************************************/

/*
 * fred port [host]
 *	Internet datagram client.
 *	Read standard input and send it to the server
 *	at the given host and port, and read and print
 *	the reply.
 *	If the host isn't given, the current host is assumed.
 */
#include <stdio.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>

char *myname;

main(argc, argv)
int argc;
char *argv[];
{
  int sock, n, port;
  char *host;
  char buf[BUFSIZ];
  struct sockaddr_in server;
  struct hostent *hp, *gethostbyname();
  
  myname = argv[0];
  if (argc < 2) {
    fprintf(stderr, "usage: %s port [host]\n", myname);
    exit(1);
  }

  port = atoi(argv[1]);
  host = (argc > 2 ? argv[2] : "localhost");

  /* create the socket */
  sock = socket(AF_INET, SOCK_STREAM, 0);
  if (sock<0) perror("socket");

  /* connect the socket to port & host */
  server.sin_family = AF_INET;
  hp = gethostbyname(host);
  if (hp == 0) {
    fprintf(stderr,"%s: %s: unknown host\n",myname,host);
    exit(1);
  }
  bcopy(hp->h_addr, &server.sin_addr, hp->h_length);
  server.sin_port = htons(port);

  if (connect(sock, &server, sizeof(server)) < 0) perror("connect");

  /*
   * Socket s is now connected to the server.
   * Data can be passed to and from the server using
   * the usual read/write calls.
   * Here we copy the standard input (unit 0) to s.
   */
  while ((n = read(0, buf, sizeof buf)) > 0) {
    write(sock, buf, n);
    n = read(sock,buf,sizeof buf);
    buf[n]=0;
    if (n > 0)
      printf("Message recieved: %s",buf);
  }
  close(sock);
  exit(0);
}

die()	/* error() calls this */
{
  exit(1);
}
