/*
 * $Id: cols.c,v 1.1 90/12/07 12:30:12 drew Exp $
 * 
 * $Log:	cols.c,v $
# Revision 1.1  90/12/07  12:30:12  drew
# Initial revision
# 
 */

/**********************************************************************
 * Copyright 1990,1991 by University of Toronto, Toronto, Ontario, Canada.
 * 
 *			 All Rights Reserved
 * 
 * Permission to use, copy, modify, distribute, and sell this software
 * and its documentation for any purpose is hereby granted without fee, 
 * provided that the above copyright notice appears in all copies and that 
 * both the copyright notice and this permission notice appear in 
 * supporting documentation, and that the name of University of Toronto 
 * not be used in advertising or publicity pertaining to distribution 
 * of the software without specific, written prior permission.  
 * University of Toronto makes no representations about the suitability 
 * of this software for any purpose. It is provided "as is" without 
 * express or implied warranty. 
 *
 * UNIVERSITY OF TORONTO DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS 
 * SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND 
 * FITNESS, IN NO EVENT SHALL UNIVERSITY OF TORONTO BE LIABLE FOR ANY 
 * SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER 
 * RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF 
 * CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN 
 * CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 *
 **********************************************************************/

#include <stdio.h>
#include <string.h>
#include <curses.h>
static char area1[100];		/* used to store mode strings */
static char bp[1024];
char *my_name;
int COLS,LINES;
int col,line;	/* current position */
int max_cols,col_width;
int clear_now = 0;
char *cm,*cl;

main(argc,argv)
int argc;
char *argv[];
{
  int co,li;
  FILE *file;
  extern char *area;
  extern char *tgetstr();
  extern char *getenv();
  my_name = argv[0];
  autoinit_blot();
  cm = tgetstr("cm",&area);
  cl = tgetstr("cl",&area);
  if (cm==NULL) {
    fprintf(stderr,"%s: terminal can't do cursor movement\n",argv[0]);
    exit(1);
  }
  if (cl==NULL) {
    fprintf(stderr,"%s: terminal can't clear home\n",argv[0]);
    exit(1);
  }
  COLS = tgetnum("co");
  LINES = tgetnum("li");
  max_cols = -1;
  argv++;
  argc--;
  while (*argv) {
    if (sscanf(*argv,"%dx%d",&li,&co)==2) {
      LINES = li;
      COLS =co;
    } else if (atoi(*argv)>0) {
      max_cols = atoi(*argv);
    } else if (!strcmp(*argv,"-help")) {
      Usage();
      exit();
    } else {
      break;
    }
    argv++;
    argc--;
  }
  if (argc>0 && max_cols==-1) max_cols = argc; /* number of files */
  if (max_cols==-1) max_cols = 2;
  col_width = COLS/max_cols;
  fputs(cl,stdout);
  if (argc==0)
    printfile(stdin);
  else
    while (*argv) {
      if (!strcmp("-",*argv))
	file = stdin;
      else {
	file = fopen(*argv,"r");
	if (file==NULL) {
	  fflush(stdout);
	  /* fputs(cl,stderr); */
	  perror(*argv);
	  exit(1);
	}
      }
      printfile(file);
      argv++;
      if (*argv) { /* there is another file - goto top of next column */
	col++;
	line = 0;
	if (col>=max_cols)
	  clear_now = 1;
	else
	  fputs(tgoto(cm,col*col_width,line),stdout);
      }
    }
  fputs(tgoto(cm,0,LINES),stdout);
}

printfile(file)
FILE *file;
{
  int c;
  while ((c=fgetc(file))!=EOF) {
    if (c==EOF) break;
    if (clear_now) {
      fputs(cl,stdout);
      line = 0;
      col = 0;
      fputs(cl,stdout);
      clear_now = 0;
    }
    if (c=='') {
      col++;
      line = 0;
      if (col>=max_cols)
	clear_now = 1;
      else
	fputs(tgoto(cm,col*col_width,line),stdout);
    } else if (c=='\n') {
      line++;
      if (line>=LINES) {
	col++;
	line = 0;
	if (col>=max_cols)
	  clear_now = 1;
      }
      if (!clear_now)
	fputs(tgoto(cm,col*col_width,line),stdout);
    } else putc(c,stdout);
  }
}

Usage()
{
  fprintf(stderr,"usage: %s [number-of-columns] [LINESxCOLS] [file1] [file2] ...\n",my_name);
}
