/*
 * $Id: test-sig.c,v 1.1 90/12/07 12:30:24 drew Exp $
 * 
 * $Log:	test-sig.c,v $
# Revision 1.1  90/12/07  12:30:24  drew
# Initial revision
# 
 */

/**********************************************************************
 * Copyright 1990,1991 by University of Toronto, Toronto, Ontario, Canada.
 * 
 *			 All Rights Reserved
 * 
 * Permission to use, copy, modify, distribute, and sell this software
 * and its documentation for any purpose is hereby granted without fee, 
 * provided that the above copyright notice appears in all copies and that 
 * both the copyright notice and this permission notice appear in 
 * supporting documentation, and that the name of University of Toronto 
 * not be used in advertising or publicity pertaining to distribution 
 * of the software without specific, written prior permission.  
 * University of Toronto makes no representations about the suitability 
 * of this software for any purpose. It is provided "as is" without 
 * express or implied warranty. 
 *
 * UNIVERSITY OF TORONTO DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS 
 * SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND 
 * FITNESS, IN NO EVENT SHALL UNIVERSITY OF TORONTO BE LIABLE FOR ANY 
 * SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER 
 * RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF 
 * CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN 
 * CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 *
 **********************************************************************/

#include <math.h>
#include <stdio.h>
typedef float real;
#include "../sim/sigmoid.h"

#define SIG 1
#define EXP 2
#define TANH 3

main(argc,argv)
int argc;
char *argv[];
{
  int n_reps,i,type;
  double x,inc,y;
  if (argc!=3) {
    fprintf(stderr,"usage: %s <n-reps> [-sig|-exp|-tanh]\n",argv[0]);
    fprintf(stderr,"%s\n%s\n%s\n%s\n%s\n",
	    "This program computes one of three smoothing functions a",
	    "specified number of times.  The three functions are:",
	    " -sig:   Sigmoid computed by table lookup with linear interpolation",
	    " -exp:   Sigmoid computed by 1/(1+exp(-x))",
	    " -tanh:  Tanh");
    exit(1);
  }
  n_reps = atof(argv[1]);
  if (!strcmp(argv[2],"-sig"))
    type = SIG;
  else if (!strcmp(argv[2],"-exp"))
    type = EXP;
  else if (!strcmp(argv[2],"-tanh"))
    type = TANH;
  else {
    fprintf(stderr,"usage: %s <n-reps> [-sig|-exp|-tanh]\n",argv[0]);
    exit(1);
  }
  inc = 10.0/n_reps;
  if (type==SIG)
    for (x= -5;x<=5;x+=inc)
      y = sigmoid(x);
  else if (type==EXP)
    for (x= -5;x<=5;x+=inc)
      y = 1/(1+exp(-x));
  else if (type==TANH)
    for (x= -5;x<=5;x+=inc)
      y = tanh(x);
}
